﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public Mode As String
End Sub

Sub Globals
	Private scvEdit As ScrollView				' ScrollView for the edit panel, added in the Edit layout
	Private lblEdit() As Label					' Labels for the edit panel, added by code in InitEditPanel
	Private edtEdit() As EditText				' EditTexts for the edit panel, added by code in InitEditPanel
	Private btnAdd, btnDelete, btnUpdate, btnPrevious, btnNext, btnFirst, btnLast As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Edit")
	Activity.Title = "SQLiteLight3  Edit"
	
	InitEditPanel
End Sub

Sub Activity_Resume
	If Starter.CurrentIndex > -1 Then
		ShowEntry(Starter.CurrentIndex)				'show the first entry
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub ShowEntry(EntryIndex As Int)
	Private col, RowID As Int
	
	If Starter.RowIDList.Size = 0 Then 	'check if database is empty
		Return														'if the database is empty leave the routine
	End If
	
	If Mode = "Add" Then
		For col = 0 To Starter.ColNumber - 1
			edtEdit(col).Text = ""
		Next
	Else
		Private ResultSet1 As ResultSet
		RowID = Starter.RowIDList.Get(EntryIndex)		'get the RowID for the given entry index
		'read the entry with the given RowID
		ResultSet1 = Starter.SQL1.ExecQuery("SELECT * FROM " & Starter.SQLTabelName & " WHERE rowid = " & RowID)
		ResultSet1.NextRow
		For col = 0 To Starter.ColNumber - 1
			edtEdit(col).Text = ResultSet1.GetString2(col)
		Next
		ResultSet1.Close	'close the ResultSet, we don't it anymore
	End If
	ShowButtons
End Sub

Sub AddEntry
	Private Query As String
	Private ResultSet1 As ResultSet
	Private col, RowID As Int
	Private Values As List
	
	'check if all dields are filled
	For col = 0 To Starter.ColNumber - 1
		If edtEdit(col).Text = "" Then
			ToastMessageShow("No entry for " & Starter.ColAliasNames(col), False)	' confirmation for the user
			Return
		End If
	Next
	
	'first we check if the entry already does exist
	Query = "SELECT * FROM " & Starter.SQLTabelName & " WHERE "
	
'	Values.Initialize
	Private Vals(Starter.ColNumber) As String
	For col = 0 To Starter.ColNumber - 1
		If col = 0 Then
			Query = Query & Starter.ColNames(col) & " = ?"
		Else
			Query = Query & " AND " & Starter.ColNames(col) & " = ?"
		End If
		Vals(col) = edtEdit(col).Text
	Next
	ResultSet1 = Starter.SQL1.ExecQuery2(Query, Vals)

	If ResultSet1.NextRow Then
		'if it exists show a message and do nothing else
		ToastMessageShow("This entry already exists", False)
	Else
		'if not, add the entry
		'a NULL for the ID column increments the primary key automatically by one
		'we use ExecNonQuery2 because it's easier, we don't need to take care of the data types 
		Query = "INSERT INTO " & Starter.SQLTabelName & " VALUES ("
		Values.Initialize
		For col = 0 To Starter.ColNumber - 1
			If col = 0 Then
				Query = Query & "?"
			Else
				Query = Query & ", ?"
			End If
			Values.Add(edtEdit(col).Text)
		Next
		Query = Query & ")"
		Starter.SQL1.ExecNonQuery2(Query, Values)
		
		ToastMessageShow("Entry added", False)	' confirmation for the user
		
		'to display the ID of the last entry we read the max value of the ID column 
		RowID = Starter.SQL1.ExecQuerySingleResult("SELECT max(rowid) FROM " & Starter.SQLTabelName)
		Starter.RowIDList.Add(RowID)												'add the last ID to the list
		Starter.CurrentIndex = Starter.RowIDList.Size - 1		'set the current index to the last one
	End If
	ResultSet1.Close												'close the ResultSet, we don't it anymore
	
	Mode = "Edit"
	
	ShowButtons
End Sub

Sub DeleteEntry
	Private Question, Query As String
	Private i, Answ As Int
	
	'ask the user for confirmation
	Question = "Do you really want to delete " 
	For i = 1 To Starter.ColNumber - 1
		Question = Question & CRLF & edtEdit(i).Text
	Next
	Answ = Msgbox2(Question, "Delete entry", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then						'if yes, delete the entry
		Query = "DELETE FROM " & Starter.SQLTabelName & " WHERE rowid = " & Starter.RowIDList.Get(Starter.CurrentIndex)
		Starter.SQL1.ExecNonQuery(Query)										'delete the entry
		Starter.RowIDList.RemoveAt(Starter.CurrentIndex)		'remove the ID from the list
		If Starter.CurrentIndex = Starter.RowIDList.Size Then		'if the current index is the last one
			Starter.CurrentIndex = Starter.CurrentIndex - 1		'decrement it by 1
		End If
		ShowEntry(Starter.CurrentIndex)									'show the next entry
		ToastMessageShow("Entry deleted", False)				'confirmation for the user
		ShowButtons
	End If
End Sub

Sub UpdateEntry
	Private Query As String
	Private col As Int
	Private Values As List
	
	Values.Initialize
	Query = "UPDATE " & Starter.SQLTabelName & " Set "
	For col = 0 To Starter.ColNumber - 1
		If col = 0 Then
			Query = Query & Starter.ColNames(col) & " = ?"
		Else
			Query = Query & ", " & Starter.ColNames(col) & " = ?"
		End If
		Values.Add(edtEdit(col).Text)
	Next
	Query = Query & " WHERE rowid = " & Starter.RowIDList.Get(Starter.CurrentIndex)
	Starter.SQL1.ExecNonQuery2(Query, Values)
	ToastMessageShow("Entry updated", False)
End Sub

Sub btnAdd_Click
	AddEntry
End Sub

Sub btnDelete_Click
	DeleteEntry
End Sub

Sub btnUpdate_Click
	UpdateEntry
End Sub

Sub btnPrevious_Click
	If Starter.CurrentIndex > 0 Then
		Starter.CurrentIndex = Starter.CurrentIndex - 1
		ShowEntry(Starter.CurrentIndex)
	End If
End Sub

Sub btnNext_Click
	If Starter.CurrentIndex < Starter.RowIDList.Size - 1 Then
		Starter.CurrentIndex = Starter.CurrentIndex + 1
		ShowEntry(Starter.CurrentIndex)
	End If
End Sub

Sub btnFirst_Click
	Starter.CurrentIndex = 0
	ShowEntry(Starter.CurrentIndex)
End Sub

Sub btnLast_Click
	Starter.CurrentIndex = Starter.RowIDList.Size - 1
	ShowEntry(Starter.CurrentIndex)
End Sub

Sub ShowButtons
	If Mode = "Add" Then
		btnPrevious.Visible = False		'hide the navigation buttons
		btnNext.Visible = False
		btnFirst.Visible = False
		btnLast.Visible = False
		btnDelete.Visible = False
		btnUpdate.Visible = False
	Else
		btnDelete.Visible = True
		btnUpdate.Visible = True
		If Starter.RowIDList.Size <= 1 Then 		'check if the database has less than 2 empty
			btnPrevious.Visible = False		'hide the navigation buttons
			btnNext.Visible = False
			btnFirst.Visible = False
			btnLast.Visible = False
		Else
			'show or hide the Previous and Next buttons depending on the value of the current index
			If Starter.CurrentIndex = 0 Then			
				btnPrevious.Visible = False
				btnFirst.Visible = False
			Else
				btnPrevious.Visible = True
				btnFirst.Visible = True
			End If
			
			If Starter.CurrentIndex = Starter.RowIDList.Size - 1 Then
				btnNext.Visible = False
				btnLast.Visible = False
			Else
				btnNext.Visible = True
				btnLast.Visible = True
			End If
		End If
	End If
End Sub

Sub InitEditPanel
	' Adds the Label and EditText views onto the ScrollView panel by code
	Private lblEdit(Starter.ColNumber) As Label
	Private edtEdit(Starter.ColNumber) As EditText
	
	Private Height = 50dip As Int
	Private VSpace = Height + 10dip As Int
	Private lblLeft = 10dip As Int
	Private lblWidth = 30%x - 10dip As Int
	Private edtLeft = 30%x + 10dip As Int
	Private edtWidth = 70%x - 20dip As Int
	Private col As Int
	
	For col = 0 To Starter.ColNumber - 1
		lblEdit(col).Initialize("")
		scvEdit.Panel.AddView(lblEdit(col), lblLeft, 10 + col * VSpace, lblWidth, Height)
		lblEdit(col).Tag = col
		lblEdit(col).Gravity = Bit.Or(Gravity.RIGHT, Gravity.CENTER_VERTICAL)
		lblEdit(col).TextSize = 16
		lblEdit(col).Text = Starter.ColAliasNames(col)
		lblEdit(col).TextColor = Colors.Blue
		
		edtEdit(col).Initialize("edtEdit")
		scvEdit.Panel.AddView(edtEdit(col), edtLeft, 10 + col * VSpace, edtWidth, Height)
		edtEdit(col).Tag = col
		edtEdit(col).TextColor = Colors.Black
	Next
	scvEdit.Panel.Height = 10dip + col * VSpace
End Sub
