﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public BooleanOperator = "AND " As String
	Public SelectedItemIndex() As Int
	Public Query = "" As String
	Public flagFilterActive = False As Boolean
End Sub

Sub Globals
	Private scvFilter As ScrollView		' ScrollView for the Filter panel
	Private spnItems() As Spinner			' Spinners for the Filter panel, added by code in InitSpinners
	Private lblItems() As Label				' Labels for the Filter panel, added by code in InitSpinners
	Private btnFilter, btnBooleanOperator As Button
	' Boolean operator used in the filter
	' can be 'OR ' or 'AND ' with a space at the end
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Title = "SQLiteLight3  Filter"

	Private spnItems(Starter.ColNumber) As Spinner
	Private lblItems(Starter.ColNumber) As Label
	If SelectedItemIndex.Length = 0 Then
		Public SelectedItemIndex(Starter.ColNumber) As Int
	End If
	InitSpinners
End Sub

Sub Activity_Resume
	'set the text of the btnBooleanOperator button
	btnBooleanOperator.Text = BooleanOperator

	'set the last selected indexes of the Spinners
	Private col As Int
	For col = 0 To Starter.ColNumber - 1
		spnItems(col).SelectedIndex = SelectedItemIndex(col)
		spnItemClick(col, SelectedItemIndex(col))
	Next
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnFilter_Click
	Query = GetFilterQuery
	
	'set the filter to active
	flagFilterActive = True
	
	'quit the Activity, returns to the DBWebView Activity
	Activity.Finish
End Sub

Sub GetFilterQuery As String
	'a query will look like something
	' WHERE FirstName = 'John'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY'
	' WHERE FirstName = 'John' AND City = 'London'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY' AND City = 'London'
	'the single quotes are needed because the values are strings

	Private Query1 = " WHERE " As String	'beginning of the query1
	
	Private col As Int
	For col = 0 To Starter.ColNumber - 1
		If SelectedItemIndex(col) > 0 Then
			If col = 0 Then
				Query1 = Query1 & Starter.ColNames(col) & " = '" & spnItems(col).SelectedItem & "' "
			Else
				If Query1 = " WHERE " Then
					Query1 = Query1 & Starter.ColNames(col) & " = '" & spnItems(col).SelectedItem & "' "
				Else
					Query1 = Query1 & BooleanOperator & Starter.ColNames(col) & " = '" & spnItems(col).SelectedItem & "' "
				End If
			End If
		End If
	Next
	
	'if nothing was selected set Query = ""
	If Query1 = " WHERE " Then
		Query1 = ""
	End If
	
	Return Query1
End Sub

Sub btnBooleanOperator_Click
	'selects the boolean operator and changes the text in the button
	If btnBooleanOperator.Text = "OR " Then
		btnBooleanOperator.Text = "AND "
		BooleanOperator = "AND "
	Else
		btnBooleanOperator.Text = "OR "
		BooleanOperator = "OR "
	End If
End Sub

'Initialize the Spinners
Sub InitSpinners
	' Adds the Label and Spinner views onto the ScrollView panel by code
	Private col As Int
	Private lblHeight = 30dip As Int
	Private spnHeight = 50dip As Int
	Private Width = 250dip As Int
	Private Left = (scvFilter.Width - Width) / 2 As Int
	Private VSpace = 20dip + lblHeight + spnHeight As Int

	For col = 0 To Starter.ColNumber - 1
		lblItems(col).Initialize("lblItems")
		scvFilter.Panel.AddView(lblItems(col), Left, 20dip + col * VSpace, Width, lblHeight)
		lblItems(col).TextSize = 16
		lblItems(col).TextColor = Colors.Blue
		lblItems(col).Text = Starter.ColAliasNames(col)
		
		spnItems(col).Initialize("spnItems")
		scvFilter.Panel.AddView(spnItems(col), Left, 20dip + lblHeight + col * VSpace, Width, spnHeight)
		spnItems(col).Tag = col
		UpdateFilter(col)
	Next
End Sub

Sub spnItems_ItemClick(Position As Int, Value As Object)
	Private spn As Spinner
	Private col As Int
	
	spn = Sender
	col =  spn.Tag
	
	spnItemClick(col, Position)
End Sub

Sub spnItemClick(col As Int, Position As Int)
	SelectedItemIndex(col) = Position
End Sub

Sub UpdateFilter(col As Int)
	Private Query1 As String
	
	Query1 = "SELECT DISTINCT " & Starter.ColNames(col) & " FROM " & Starter.SQLTabelName & " ORDER BY " & Starter.ColNames(col) & " ASC"
	
	spnItems(col).Clear
	spnItems(col).Add("no filter")
	
	Private ResultSet1 As ResultSet
	ResultSet1 = Starter.SQL1.ExecQuery(Query1)
	
	Do While ResultSet1.NextRow
		spnItems(col).Add(ResultSet1.GetString(Starter.ColNames(col)))
	Loop

	ResultSet1.Close
End Sub

